// ==UserScript==
// @name          Folders4Gmail
// @namespace     http://www.arend-von-reinersdorff.com/folders4gmail/
// @homepage     http://www.arend-von-reinersdorff.com/folders4gmail/
// @description   Lists labels in a folder-like hierarchy.
// @include       http://mail.google.com/*
// @include       https://mail.google.com/*

// @author Arend v. Reinersdorff
// @tab Sidebar
// @conflict folders4gmailredesigned
// @conflict labellinks4gmail
// ==/UserScript==


/*
 * Version 1.36, 17. April 2008
 * Written by Arend v. Reinersdorff, www.arend-von-reinersdorff.com
 * This script is Public Domain. You are welcome to use it in any way you like.
 */

//refresh is set only once, in the top frame
// G. Trapani:  Had to take out this if, it kept script from working in Better Gmail 2.
//if(document.location == top.location){
(function(){

//select UI
var uiHandler;
if(document.getElementById("canvas_frame")){
    uiHandler = new ui2Handler();
}else if(1 == document.getElementsByTagName("frameset").length){
    uiHandler = new ui1Handler();
}

if(uiHandler){
    window.setInterval(uiHandler.refreshSublabels, 100);
}

function ui2Handler(){

    //check if lables need to be updated
    this.refreshSublabels = function(){
        //label added, renamed, removed or labels recreated
        if(!frames[3].document.getElementById("nb1Q2b")){
            initLabels(frames[3].document);
        }

        if(window.location.href.indexOf("#label/") != -1){
            var locationHash = window.location.href.replace(/^[^#]+(#.*)$/, "$1");
            locationHash = locationHash.replace("+", " ");
            locationHash = decodeURIComponent(locationHash);
            expandActiveLabel(locationHash.substring(7));
        }else{
            lastActiveLabelName = "";
        }


        //check for change in unread emails
        for(var labelName in labelMap){
            if(labelMap[labelName].domNode.className.indexOf("f4g_modified") == -1){
                refreshUnreadCounts();
                break;
            }
        }
    };

    this.labelNodeIterator = function(doc){
        var labelNodes = new Array(0);
        var divNodes = doc.getElementsByTagName("div");
        for(var i = 0; i < divNodes.length; i++){
            if(divNodes[i].className == "nb1Q2b"
                && divNodes[i].firstChild
                && divNodes[i].firstChild.firstChild
                && divNodes[i].firstChild.firstChild.firstChild
                && divNodes[i].firstChild.firstChild.firstChild.childNodes
            ){
                divNodes[i].id = "nb1Q2b";
                labelNodes = divNodes[i].firstChild.firstChild.firstChild.childNodes;
                break;
            }
        }

        var iterator = function(nodes){
            this.labelNodes = nodes;
            this.index = 0;
            this.hasNext = function(){
                return (this.index < this.labelNodes.length);
            };
            this.next = function(){
                var labelNode = this.labelNodes[this.index].firstChild.firstChild.firstChild;
                this.index++;
                return labelNode;
            };
            this.revert = function(){
                this.index--;
            };
        };
        return new iterator(labelNodes);
    };

    this.getTitleNode = function(labelNode){
        return labelNode.firstChild;
    }

    this.getTextNode = function(labelNode){
        return labelNode.firstChild;
    };


    this.hasUnreadMessages = function(labelNode){
        return labelNode.className.indexOf("PQmvpb") != -1;
    };


    this.addMissingParentNode = function(missingParentName, labelNode){
        var trNode    = labelNode.parentNode.parentNode.parentNode;
        var newTrNode = trNode.cloneNode(true);
            newTrNode.lastChild.removeAttribute("id");
            newTrNode.lastChild.style.visibility = "hidden";
        var domNode = newTrNode.firstChild.firstChild.firstChild;

            //prevent action on click
            domNode.id = "";
            domNode.firstChild.removeAttribute("href");
            domNode.firstChild.className += " f4g_fake";

            //ensure not bold, not found by gmail macros
            domNode.className = "";
            domNode.style.paddingBottom = "4px";

            domNode.firstChild.firstChild.data = missingParentName;
            domNode.firstChild.style.cursor         = "default";
            domNode.firstChild.style.textDecoration = "none";
            domNode.firstChild.style.fontStyle      = "italic";
        trNode.parentNode.insertBefore(newTrNode, trNode);
    };


    this.setDisplay = function(label, displayString){
        label.domNode.parentNode.parentNode.parentNode.style.display = displayString;
    };


    this.setExpanderIcon = function(label){
        label.expanderNode.className = (label.isExpanded) ? "f4g_expander Jyd7m" : "f4g_expander v2dpPe";
    };


    this.expanderInnerHTML = function(){
        return '<div class="R7iiN"  style="position: absolute; margin-top: 3px; margin-left: 1px; width: 10px; height: 12px;"></div>'
             + '<div class="R7iiN"  style="position: absolute; margin-top: 4px; margin-left: 0px; width: 12px; height: 10px;"></div>'
             + '<img class="LrIFMe" style="position: absolute; margin-top: 4px; margin-left: 1px; cursor: pointer; display: block;" src="images/cleardot.gif">';
    };
};


function ui1Handler(){

this.lastIframeId = "";
    //check if the sublabels need to be recreated after a reload
    this.refreshSublabels = function(){

        //find active iframe
        var doc;
        for (var i = 0; i <= 3; i++){
            if(!frames[0] || !frames[0].frames[i]){
                return;
            }

            var iframeNode = frames[0].document.getElementById("v" + (i+1));
            if(iframeNode.style.left.indexOf("0") == 0){
                doc = frames[0].frames[i].document;
                break;
            }
        }

        if(doc){
            var editNode = doc.getElementById("prf_l");
            if(editNode && (!editNode.title)){
                editNode.title = editNode.firstChild.data;
                initLabels(doc);
                refreshUnreadCounts();
            }

            //expand label and parent labels if user is in label view
            var noLabelFound = true;
            for(var labelName in labelMap){
                if(doc.getElementById("ac_rc_" + labelName)){
                    expandActiveLabel(labelName);
                    noLabelFound = false;
                    break;
                }
            }
            if(noLabelFound){
                lastActiveLabelName = "";
            }
        }
    };


    this.labelNodeIterator = function(doc){
        var labelNodes  = new Array(0);
        var editNode = doc.getElementById("prf_l");
        if(editNode){
            labelNodes = editNode.parentNode.childNodes;
        }

        var iterator = function(nodes){
            this.labelNodes = nodes;
            this.index = 0;
            this.hasNext = function(){
                return (this.index < this.labelNodes.length-1);
            };
            this.next = function(){
                var labelNode = this.labelNodes[this.index];
                this.index++;
                return labelNode;
            };
            this.revert = function(){
                this.index--;
            };
        };
        return new iterator(labelNodes);
    };

    this.getTitleNode = function(labelNode){
        return labelNode;
    }

    this.getTextNode = function(labelNode){
        var textNode = labelNode;
        if(this.hasUnreadMessages(labelNode)){
            textNode = textNode.firstChild;
        }
        return textNode;
    };


    this.hasUnreadMessages = function(labelNode){
        return labelNode.firstChild.nodeName == "B";
    };


    this.addMissingParentNode = function(missingParentName, labelNode){
        var domNode = labelNode.cloneNode(true);
            domNode.id = "f4_" + missingParentName;
            domNode.style.cursor         = "default";
            domNode.style.textDecoration = "none";
            domNode.style.fontStyle      = "italic";

        var textNode = domNode.firstChild;

        //ensure not bold
        if(this.hasUnreadMessages(domNode)){
            var textNode = textNode.firstChild;
            domNode.removeChild(domNode.firstChild);
            domNode.appendChild(textNode);
        }

        textNode.data = missingParentName
        labelNode.parentNode.insertBefore(domNode, labelNode);
    };


    this.setDisplay = function(label, displayString){
        label.domNode.style.display = displayString;
        if(label.childLabels.length > 0){
            //fix Gmail Super Clean skin
            if(displayString == ""){
                displayString = "block";
            }

            label.domNode.previousSibling.style.display = displayString;
        }
    };


    this.setExpanderIcon = function(label){
        var imgNode = label.expanderNode.lastChild;
        imgNode.style.background = (label.isExpanded) ? "url(images/2/5/c/icons4.png) -70px -30px" : "url(images/2/5/c/icons4.png) -60px -20px";
    };


    this.expanderInnerHTML = function(){
        return '<div style="position: absolute; margin-top: 3px; margin-left: 1px; width: 10px; height: 12px; background: #B5EDBC; overflow: visible; font-size: 0;"></div>'
             + '<div style="position: absolute; margin-top: 4px; margin-left: 0px; width: 12px; height: 10px; background: #B5EDBC;"></div>'
             + '<img style="position: absolute; margin-top: 4px; margin-left: 1px; width: 10px; height: 10px; cursor: pointer; display: block;" src="images/cleardot.gif">';
    };
};


var lastActiveLabelName  = "";
var labelMap        = new Object();
var labelNameList   = new Array();


//init labelMap and labelNameList, add expander and indention to nodes
function initLabels(doc){
    //set parentLabel and childLabels, create labelMap, labelNameList
    var newLabelMap = new Object();
    var labelStack  = new Array();
    labelNameList   = new Array();
    var labelNodeIterator = uiHandler.labelNodeIterator(doc);
    while(labelNodeIterator.hasNext()){
        var labelNode = labelNodeIterator.next();
        var labelName = (labelNode.textContent) ? labelNode.textContent : labelNode.innerText;
        if(uiHandler.hasUnreadMessages(labelNode)){
            labelName = uiHandler.getTitleNode(labelNode).title;
            var limit = labelName.lastIndexOf(" ");
            labelName = labelName.substring(0, limit);
        }

        //look for a parent on the stack
        var parentLabelName = null;
        while(labelStack.length > 0){
            var stackLabelName = labelStack.pop();
            if(isParentLabelOf(stackLabelName, labelName)){
                labelStack.push(stackLabelName);
                parentLabelName = stackLabelName;
                break;
            }
        }

        //if a missing parent was inserted into the document,
        //start the loop again at the position of the inserted parent
        if(addMissingParent(parentLabelName, labelName, labelNode)){
            labelNodeIterator.revert();
            continue;
        }

        //create Label object and set properties
        var label = (labelMap[labelName]) ? labelMap[labelName] : new Label(labelName);
        label.reset(labelNode);
        if(parentLabelName){
            var parentLabel = newLabelMap[parentLabelName];
            parentLabel.childLabels.push(label);
            label.parentLabel = parentLabel;
        }

        //update collections
        newLabelMap[labelName] = label;
        labelStack.push(labelName);
        labelNameList.push(labelName);
    }
    labelMap = newLabelMap;

    //add expander and indention
    for(var i = labelNameList.length-1; i >= 0; i--){
        var labelName = labelNameList[i];
        var label = labelMap[labelName];
        var indentionLevel = label.indentionLevel;
        if(label.childLabels.length > 0){
            var expanderNode = createExpandSign(doc, label);
            label.expanderNode = expanderNode;
            label.domNode.parentNode.insertBefore(expanderNode, label.domNode);

            //collapse labels
            label.isExpanded = !label.isExpanded;
            changeExpand(label);

            indentionLevel--;
        }

        var indentedNode = label.domNode;
        if(label.childLabels.length > 0){
            indentedNode = expanderNode;
        }
        indentedNode.style.marginLeft = "" + indentionLevel*14 + "px";
        label.domNode.style.width = "auto";
    }
}


//expand label in active view
function expandActiveLabel(labelName){
    var label = labelMap[labelName];
    if((labelName == lastActiveLabelName) || !label){
        return;
    }
    lastActiveLabelName = labelName;

    if(label.childLabels.length == 0){
        label = label.parentLabel;
    }
    while(label){
        if(!label.isExpanded){
            changeExpand(label);
        }
        label = label.parentLabel;
    }
}


//refreshes the label count in brackets for all labels
function refreshUnreadCounts(){
    var labelsToUpdate = new Object();

    //from bottom to top
    for (var i = labelNameList.length-1; i >= 0; i--){
        var label = labelMap[labelNameList[i]];

        //if label is modified
        if(label.domNode.className.indexOf("f4g_modified") == -1){
           label.domNode.className +=     " f4g_modified";

            label.normalUnreadCount = 0;
            if(uiHandler.hasUnreadMessages(label.domNode)){
                var text = uiHandler.getTitleNode(label.domNode).title;
                var regexResult = text.match(/\((\d+)\)$/);
                label.normalUnreadCount = parseInt(regexResult[1]);
            }

            labelsToUpdate[label] = true;
        }

        //if label must be updated
        if(labelsToUpdate[label]){
            labelsToUpdate[label.parentLabel] = true;

            label.summedUnreadCount = label.normalUnreadCount;
            for(var j = 0; j < label.childLabels.length; j++){
                label.summedUnreadCount += label.childLabels[j].summedUnreadCount;
            }

            var textNode       = uiHandler.getTextNode(label.domNode);
            var unreadCount    = (label.summedUnreadCount) ? " ("+label.summedUnreadCount +")" : "";
            textNode.innerHTML = label.htmlName + unreadCount;
            textNode.title     = labelNameList[i] + unreadCount;
        }
    }
}


//label object
function Label(fullLabelName){
    this.isExpanded = false;

    //set shortName
    labelName           = standardSeparator(fullLabelName);
    this.indentionLevel = labelName.split("/").length;
    var nameIndex       = labelName.lastIndexOf("/") + 1;
    labelName           = labelName.substring(nameIndex);
    labelName           = labelName.replace(/^ *([^ ].*)$/, "$1");
    labelName           = labelName.replace(/^(.*[^ ]) *$/, "$1");

    //empty label name, doesn't work with Gmail Macros
    if(/^ *$/.test(labelName)){
        this.htmlName = "\u00A0";

    //fix for Gmail Macros
    }else{
        var nameStarts = fullLabelName.indexOf(labelName);
        var prefix = fullLabelName.substring(0, nameStarts);
        if(nameStarts > 0){
            prefix = '<span style="display:none;">' + prefix + '</span>';
        }

        var suffix = fullLabelName.substring(nameStarts + labelName.length);
        if(suffix != ""){
            suffix = '<span style="display:none;">' + suffix + '</span>';
        }

        this.htmlName = prefix + labelName + suffix;
    }

    //for properties that change after label box redraw
    this.reset = function(domNode){
        this.domNode     = domNode;
        this.parentLabel = null;
        this.childLabels = new Array();
    }
}


//check for parent label
function isParentLabelOf(parentLabelName, labelName){
    parentLabelName = standardSeparator(parentLabelName).toLowerCase() + "/";
    labelName       = standardSeparator(labelName).toLowerCase();
    return (labelName.indexOf(parentLabelName) == 0);
}


//if the parent label is not the direct parent, create the next missing parent in the document
//for example ("a", a/b/c/d") -> create "a/b"
//the input must be a real parent label
function addMissingParent(parentLabelName, labelName, labelNode){
    labelNameEscaped       = standardSeparator(labelName);
    var parentNameLenth    = (parentLabelName) ? parentLabelName.length+1 : 0;
    var missingParentLimit = labelNameEscaped.indexOf("/", parentNameLenth);
    var missingParentName  = (missingParentLimit > 0) ? labelName.substring(0, missingParentLimit) : null;

    if(missingParentName){
        uiHandler.addMissingParentNode(missingParentName, labelNode);
    }

    return missingParentName;
}


//create a new expand sign
function createExpandSign(doc, label){
    var expNode = doc.createElement("div");
        expNode.style.cssFloat    = "left";
        expNode.style.styleFloat  = "left"; //float for Internet Explorer
        expNode.style.width       = "14px";
        expNode.style.height      = "15px";
        expNode.style.display     = "block"; // fix for Gmail super clean skin
        expNode.innerHTML = uiHandler.expanderInnerHTML();

    var onclickFunction = function(){
        changeExpand(label);
    };
    //set events
    if(expNode.addEventListener){
        expNode.lastChild.addEventListener("click", onclickFunction, false);
    }
    //for Internet Explorer
    else if(expNode.attachEvent){
        expNode.lastChild.attachEvent("onclick", onclickFunction);
    }

    return expNode;
}


//event for a click on an expander
function changeExpand(label){
    label.isExpanded = !label.isExpanded;
    uiHandler.setExpanderIcon(label);
    var displayString = (label.isExpanded) ? "" : "none";

    //change display of child labels
    var changeDisplayed = new Array(label);
    while(changeDisplayed.length > 0){
        var changedLabel = changeDisplayed.pop();
        for(var i = 0; i < changedLabel.childLabels.length; i++){
            var childLabel = changedLabel.childLabels[i];
            if(childLabel.isExpanded){
                changeDisplayed.push(childLabel);
            }
            uiHandler.setDisplay(childLabel, displayString);
        }
    }
}


//convert separators that don't make sense to spaces
function standardSeparator(labelName){
    //converts the legacy separator "\" to "/"
    labelName = labelName.replace(/\\/g, "/");

    //convert end slashes to spaces
    var endRegexp = new RegExp("/(/+)$");
    while(endRegexp.test(labelName)){
            labelName = labelName.replace(endRegexp, " $1");
    }
    labelName = labelName.replace(new RegExp("/$"), " ");


    //convert "//" to "/ "
    var regexp = new RegExp("(/+)/");
    while(regexp.test(labelName)){
        labelName = labelName.replace(regexp, "$1 ");
    }
    labelName = labelName.replace(new RegExp("^/"), " ");

    return labelName;
}


})(); //end anonymous function
