// ==UserScript==
// @name          LabelLinks4Gmail
// @namespace     http://www.benpaigeIII.com/labellinks4gmail/
// @description   Label your labels as well as your email.

// @include        http://mail.google.com/*
// @include        https://mail.google.com/*

// @homepage     http://userscripts.org/scripts/show/30757
// @tab Sidebar
// @author Benjamin Paige III
// @conflict folders4gmailredesigned
// @conflict folders4gmail
// ==/UserScript==


/*
 * Version 2.4  September 25, 2008
 * Written by Benjamin Paige III
 * This script is Public Domain. You are welcome to use it in any way you like.
 * This script is derived from Arend v. Reinersdorff's Folders4Gmail.  See www.arend-von-reinersdorff.com.
 */

//refresh is set only once, in the top frame
// Gina Trapani: Had to take out this top frame if to make this script work in Better Gmail 2
// Gina Trapani: for reasons not entirely obvious to me, had to take out the anonymous function wrapper as well for BG 2 functionality--script-compiler wraps it anonymously, so it's not a security problem, but this is not true for folders4gmail.user.js, so it's a head-scratcher.
var searchURL = "http://mail.google.com/mail/#search/";
var metaClause = "label%3A";

//select UI
var uiHandler;
if(document.getElementById("canvas_frame")){
    uiHandler = new ui2Handler();
}else if(1 == document.getElementsByTagName("frameset").length){
    uiHandler = new ui1Handler();
}

if(uiHandler){
    window.setInterval(uiHandler.refreshSublabels, 100);
    window.setInterval(uiHandler.reformatLabels, 100);
}



function ui2Handler(){

    //check if lables need to be updated
    this.refreshSublabels = function(){
    
        //label added, renamed, removed or labels recreated
        if(!frames[3].document.getElementById("nb1Q2b")){
            initLabels(frames[3].document);
        }
		
        //expand label and parent labels if user is in label view
        var locationHash = window.location.hash;
        //Firefox Bug, location.hash is decoded
        if(location.href.indexOf(locationHash) >= -1){
            locationHash = decodeURIComponent(locationHash);
        }
        if(locationHash.indexOf("#label/") != -1){
            expandActiveLabel(locationHash.substring(7));
        }else{
            lastActiveLabelName = "";
        }

        //check for change in unread emails
        for(var labelName in oldLabelMap){
            if(oldLabelMap[labelName].className.indexOf("f4g_modified") == -1){
                refreshUnreadCounts();
                break;
            }
        }
    };
	
	this.reformatLabels = function(){
		if(zzz_LL4G_Advanced)	{
			var divNodes = frames[3].document.getElementsByTagName("DIV");
		
			for(i = 0; i < divNodes.length; i++) {
				if("krEW7c" == divNodes[i].className) {
					divNodes[i].className += " ll4G_modified";
					var value = divNodes[i].innerHTML;
					divNodes[i].innerHTML = value.split(':')[0];
				}
			}
		}
	};


   this.labelNodeIterator = function(doc){
        var labelNodes = new Array(0);
        var divNodes = doc.getElementsByTagName("div");
        for(var i = 0; i < divNodes.length; i++){
            if(divNodes[i].className == "nb1Q2b"
                && divNodes[i].firstChild
                && divNodes[i].firstChild.firstChild
                && divNodes[i].firstChild.firstChild.firstChild
                && divNodes[i].firstChild.firstChild.firstChild.childNodes
            ){
                divNodes[i].id = "nb1Q2b";
                labelNodes = divNodes[i].firstChild.firstChild.firstChild.childNodes;
                break;
            }
        }

        var iterator = function(nodes){
            this.labelNodes = nodes;
            this.index = 0;
            this.hasNext = function(){
                return (this.index < this.labelNodes.length);
            };
            this.next = function(){
                var labelNode = this.labelNodes[this.index].firstChild.firstChild.firstChild;
                this.index++;
                return labelNode;
            };
            this.revert = function(){
                this.index--;
            };
        };
        return new iterator(labelNodes);
    };

    this.getTitleNode = function(labelNode){
        return labelNode.firstChild;
    }

    this.getTextNode = function(labelNode){
        return labelNode;
    };


    this.hasUnreadMessages = function(labelNode){
        return labelNode.className.indexOf("PQmvpb") != -1;
    };







    this.addMissingParentNode = function(missingParentName, labelNode){
        var trNode    = labelNode.parentNode.parentNode.parentNode;
        var newTrNode = trNode.cloneNode(true);
            newTrNode.lastChild.removeAttribute("id");
            newTrNode.lastChild.style.visibility = "hidden";
        var domNode = newTrNode.firstChild.firstChild.firstChild;

            //prevent action on click
            domNode.id = "";


            domNode.firstChild.removeAttribute("href");

            //ensure not bold, not found by gmail macros
            domNode.className = "";
            domNode.style.paddingBottom = "4px";

            domNode.firstChild.firstChild.data = missingParentName;
            domNode.firstChild.style.cursor = "default";
            domNode.firstChild.style.textDecoration = "none";
        trNode.parentNode.insertBefore(newTrNode, trNode);
    };


    this.setDisplay = function(label, displayString){
        label.domNode.parentNode.parentNode.parentNode.parentNode.style.display = displayString;
    };
};








function ui1Handler(){

	this.lastIframeId = "";
    //check if the sublabels need to be recreated after a reload
    this.refreshSublabels = function(){

        //find active iframe
        var doc;
        for (var i = 0; i <= 3; i++){
            if(!frames[0] || !frames[0].frames[i]){
                return;
            }

            var iframeNode = frames[0].document.getElementById("v" + (i+1));
            if(iframeNode.style.left.indexOf("0") == 0){
                doc = frames[0].frames[i].document;
                break;
            }
        }

        if(doc){
            var editNode = doc.getElementById("prf_l");
            if(editNode && (!editNode.title)){
                editNode.title = editNode.firstChild.data;
                initLabels(doc);
                refreshUnreadCounts();
            }

            //expand label and parent labels if user is in label view
            var noLabelFound = true;
            for(var labelName in labelMap){
                if(doc.getElementById("ac_rc_" + labelName)){
                    expandActiveLabel(labelName);
                    noLabelFound = false;
                    break;
                }
            }
            if(noLabelFound){
                lastActiveLabelName = "";
            }
        }
    };


    this.labelNodeIterator = function(doc){
        var labelNodes  = new Array(0);
        var editNode = doc.getElementById("prf_l");
        if(editNode){
            labelNodes = editNode.parentNode.childNodes;
        }

        var iterator = function(nodes){
            this.labelNodes = nodes;
            this.index = 0;
            this.hasNext = function(){
                return (this.index < this.labelNodes.length-1);
            };
            this.next = function(){
                var labelNode = this.labelNodes[this.index];
                this.index++;
                return labelNode;
            };
            this.revert = function(){
                this.index--;
            };
        };
        return new iterator(labelNodes);
    };

    this.getTitleNode = function(labelNode){
        return labelNode;
    }

    this.getTextNode = function(labelNode){
        var textNode = labelNode;
        if(this.hasUnreadMessages(labelNode)){
            textNode = textNode.firstChild;
        }
        return textNode;
    };


    this.hasUnreadMessages = function(labelNode){
        return labelNode.firstChild.nodeName == "B";
    };


    this.addMissingParentNode = function(missingParentName, labelNode){
        var domNode = labelNode.cloneNode(true);
            domNode.id = "f4_" + missingParentName;
            domNode.style.cursor = "default";
            domNode.style.textDecoration = "none";

        var textNode = domNode.firstChild;

        //ensure not bold
        if(this.hasUnreadMessages(domNode)){
            var textNode = textNode.firstChild;
            domNode.removeChild(domNode.firstChild);
            domNode.appendChild(textNode);
        }

        textNode.data = missingParentName
        labelNode.parentNode.insertBefore(domNode, labelNode);
    };


    this.setDisplay = function(label, displayString){
        label.domNode.style.display = displayString;
        if(label.childLabels.length > 0){
            //fix Gmail Super Clean skin
            if(displayString == ""){
                displayString = "block";
            }

            label.domNode.previousSibling.style.display = displayString;
        }

    };
};


var highlightedLabelName = null;
var lastActiveLabelName  = "";
var labelMap        = new Object();
var oldLabelMap        = new Object();
var labelEditBoxMap = new Object();
var labelNameList   = new Array();
var labelArr = new Array();
var dataURIs        = new Object();
var zzz_LL4G_Advanced = false;
var labelLookup;
var divLookup;
    dataURIs[true]  = new Object();
    dataURIs[false] = new Object();
    //dataURIs[isExpanded][isHighlighted]
    dataURIs[true][true]   = "data:image/gif;base64,R0lGODlhDAAMALMJAHejQf///4KrUbfOmrTMloWtVbnPnYSsU7XNmP///wAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAkALAAAAAAMAAwAAAQiMJkCqi0mDcvtEF0HhmTJBWiKnmpqvuRYCpuJJMQRHkQSAQA7";
    dataURIs[true][false]  = "data:image/gif;base64,R0lGODlhDAAMALMPAP///3ejQYKrUfT377fOmrTMlvL27YSsU/H164WtVb3To7nPncHVqLXNmL/Upv///yH5BAEAAA8ALAAAAAAMAAwAAAQw8K0Uqk3rEYWA/4hCCMNnAoMQnGfFmq4lr/Fcv5+LAwGJpwSHgWVgNB6Fg+1QeEQAADs=";
    dataURIs[false][true]  = "data:image/gif;base64,R0lGODlhDAAMALMJAHejQf///4KrUbfOmrTMloWtVbnPnYSsU7XNmP///wAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAkALAAAAAAMAAwAAAQpMJkCqi0mDcvtEFwQcGA4diYKiCxrtqIaq9VslfVZCRsNIAnCAXUgJCIAOw==";
    dataURIs[false][false] = "data:image/gif;base64,R0lGODlhDAAMALMPAP///3ejQYKrUfT377fOmrTMlvL27YSsU/H164WtVb3To7nPncHVqLXNmL/Upv///yH5BAEAAA8ALAAAAAAMAAwAAAQ08K0Uqk3rEYWA/4hCCMNXfYMQfMBpri97WvQ617cMey6/t6SYJ0VwGFgeA6PxKBxwh8IjAgA7";

//fix for ie7pro
var img1 = document.createElement("img");
    img1.src = dataURIs[true][true];
var img2 = document.createElement("img");
    img2.src = dataURIs[true][false];
var img3 = document.createElement("img");
    img3.src = dataURIs[false][true];
var img4 = document.createElement("img");
    img4.src = dataURIs[false][false];


function trim(stringToTrim) {
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}

function loadLabels(label, node, level) {
	label.indentionLevel = level;
	level++;
	node.appendChild(label.getRowNode());
	
	for(index in label.childLabels)
		loadLabels(label.childLabels[index], node, level);
		
	level--;
}

function clearLabels() {
	for(index in labelArr) 	{
		var labelNode = labelArr[index].getRowNode();
		var parentNode = labelNode.parentNode;
		
		parentNode.removeChild(labelNode);
	}
}


	
function createLabels(labelName, relationMap, fullLabelMap, parentName) {
	
	//create Label object and set properties
	var label =  new Label(labelName + parentName);
	
	label.fullLabelName = fullLabelMap[labelName];
	labelMap[label.id] = label;
	labelArr.push(label);
	
	var cloneNode = oldLabelMap[labelName].parentNode.parentNode.parentNode.cloneNode(true);
	if(parentName == "")
		cloneNode.appendChild(labelEditBoxMap[labelName]);
	label.setRowNode(cloneNode);
	label.labelEditBox = labelEditBoxMap[labelName];
	
	if(relationMap[labelName].length > 0) 	{
		var childLabels = relationMap[labelName].split(",");
		
		for(index in childLabels)
			label.addChild(createLabels(childLabels[index], relationMap, fullLabelMap, "~" + label.id));
	}
	
	return label;
}

function getTopLookupLabel(labelName) {
	for(index in labelArr) 	{
		var label = labelArr[index];
	
		if(labelName == label.labelName) 		{
			return label;
		}
	}
}




var highlightedNode;

function highlightNode(node) {
	unhighlightNode();
	
	if(node) 	{
		node.style.backgroundColor = '#EEEEEE';
		highlightedNode = node
	}
}

function unhighlightNode() {
	if(highlightedNode) 	{
		highlightedNode.style.backgroundColor = '';
	}
}

function labelKeyPressed(e) {
	if(e.keyCode == 13 && highlightedNode) 	{
		var label = getTopLookupLabel(highlightedNode.innerHTML);
		location.href = label.getHREF();
		labelLookup.value = '';
		divLookup.style.visibility = 'hidden';
		return;
	}
	
	if(e.keyCode == 40) 	{
		highlightNode(highlightedNode.nextSibling);
		return;
	}
	
	if(e.keyCode == 38) 	{
		highlightNode(highlightedNode.previousSibling);
		return;
	}
	
	divLookup.innerHTML = '';
	
	divLookup.style.visibility = '';

	var labelExp = new RegExp(labelLookup.value,"i");
	
	for(index in labelNameList) 	{
		var labelName = labelNameList[index];
		
		if(labelExp.test(labelName)) 		{
			for(index2 in labelArr) 	{
				var label = labelArr[index2];
			
				if(labelName == label.labelName) {
					divLookup.innerHTML += '<a class="LabelLookup" style="display:block;color:#063" href="' + label.getHREF()  + '" target="_top">' + label.labelName + '</a>';
					break;
				}
			}
			
		}
	}
	
	highlightNode(divLookup.firstChild);
}





function createLabelLookup(labelBox) {
	labelLookup = document.createElement("input");
    labelLookup.id = 'labelLookup';
	labelLookup.name = 'labelLookup';
	labelLookup.type = 'text';
	labelLookup.value = '';
	labelLookup.className = 'oPfZKb u4Qprd';
	
	divLookup = document.createElement("div");
	divLookup.id = 'divLookup';
	divLookup.style.border = 'gray solid 1px';
	divLookup.style.position = 'absolute';
	divLookup.style.backgroundColor = 'white';
	divLookup.style.visibility = "hidden";
	divLookup.style.zIndex = "100";
	divLookup.style.minWidth = "100px";
	divLookup.style.maxHeight = "300px";
	divLookup.style.overflowY = "scroll";
	labelBox.insertBefore(divLookup, labelBox.firstChild);
	labelBox.insertBefore(labelLookup, divLookup);
	
    labelLookup.addEventListener("keyup",   labelKeyPressed, false);
    //labelLookup.addEventListener("blur",   function(e){if(e.target.className != 'LabelLookup')divLookup.style.visibility='hidden';}, false);
    divLookup.addEventListener("mouseout",   function(e){if(e.relatedTarget.className != 'LabelLookup')divLookup.style.visibility='hidden';}, false);

}

//init labelMap and labelNameList, add expander and indention to nodes
function initLabels(doc){
	clearLabels();
    //set parentLabel and childLabels, create labelMap, labelNameList
    labelArr = new Array();
    labelNameList   = new Array();
	var relationMap = new Object();
	var displayMap = new Array();
	var fullLabelMap = new Object();
    var labelNodeIterator = uiHandler.labelNodeIterator(doc);
    while(labelNodeIterator.hasNext()){
        var labelNode = labelNodeIterator.next();
		var rowNode = labelNode.parentNode.parentNode.parentNode;
		
        var labelName = (labelNode.textContent) ? labelNode.textContent : labelNode.innerText;
		
		if(labelName == "zzz_LL4G_Advanced") {
			zzz_LL4G_Advanced = true;
			rowNode.style.display = "none";
			continue;
		}
			
 	
        if(uiHandler.hasUnreadMessages(labelNode)){
            labelName = uiHandler.getTitleNode(labelNode).title;
            var limit = labelName.lastIndexOf(" ");
            labelName = labelName.substring(0, limit);
        }
		
		var fullLabelName = labelName;
		var labelNameArr = labelName.split(":");
		labelName = trim(labelNameArr[0]);
		
		labelNameList.push(labelName);
		oldLabelMap[labelName] = labelNode;
		
		labelEditBoxMap[labelName] = rowNode.lastChild;
		rowNode.removeChild(labelEditBoxMap[labelName]);
		
		if(!relationMap[labelName])
			relationMap[labelName] = "";
		
		if(labelNameArr.length == 2) 	{
			var parents = labelNameArr[1].split(",");
			
			for(var i = 0; i < parents.length; i++) 			{
				var parentName = trim(parents[i]);
				if(!relationMap[parentName])
					relationMap[parentName] = labelName;
				else
					relationMap[parentName] += "," + labelName;
			}
		} 		else 		{
			displayMap.push(labelName);
		}
		
		fullLabelMap[labelName] = fullLabelName;
		
		//Hide all gmail labels
		rowNode.style.display = "none";
		
		lastNode = labelNode;
    }
	
	
	for(index in displayMap) 	{
		var labelName = displayMap[index];
		
		createLabels(labelName, relationMap, fullLabelMap, "");
	}
	
	for(index in labelArr) 	{
		var label = labelArr[index];
		if(label.parentLabel == null) 		{
			loadLabels(label, labelNode.parentNode.parentNode.parentNode.parentNode, 1);
		}
	}
	
    //add expander and indention
    for(var i = labelArr.length-1; i >= 0; i--){
        var label = labelArr[i];
        var labelName = label.labelName;
        var indentionLevel = label.indentionLevel;
		
        if(label.childLabels.length > 0){
            var expanderNode = createExpandSign(doc, label.id);
            label.domNode.parentNode.insertBefore(expanderNode, label.domNode);

            //collapse labels
            label.isExpanded = !label.isExpanded;
            changeExpand({target : expanderNode});

            indentionLevel--;
        }

        var indentedNode = label.domNode;
        if(label.childLabels.length > 0){
            indentedNode = expanderNode;
        }
		
        indentedNode.style.marginLeft = "" + indentionLevel*14 + "px";
        label.domNode.style.width = "auto";
    }
	
	var labelBox = lastNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode;
	createLabelLookup(labelBox);
		
	if(zzz_LL4G_Advanced) 	{
		var labelDiv = lastNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode;

		labelDiv.addEventListener("mouseout",   function(e){labelDiv.style.width = '';labelDiv.style.position = '';labelDiv.style.zIndex = '';}, false);
		labelDiv.addEventListener("mousemove",   function(e){labelDiv.style.width = '350px';labelDiv.style.position = 'absolute';labelDiv.style.zIndex = '100';}, false);
	}
}





function isDescendentElement(baseNode,node, levelMax) {
	for(var i = 0; i < levelMax; i++) 	{
		if(baseNode == node || baseNode == node.parentNode)
			return true;
		else
			node = node.parentNode;
	}
	
	return false;
}



function getQueryLabel(label) {
	return metaClause + label.fullLabelName.replace(" ", "-", "gi").replace("\\", "%5C");
}

//Recursive function that builds a query string of all child labels
function AppendChildLabelClauses(parentLabel) {
		var queryString = "";
		
		for(index in parentLabel.childLabels)		{ 
			var label = parentLabel.childLabels[index];
			
			queryString += "+OR+" + getQueryLabel(label) + AppendChildLabelClauses(label);
		}
		
		return queryString;
}


//expand label in active view
function expandActiveLabel(labelName) { 
    var label = labelMap[labelName];
    if((labelName == lastActiveLabelName) || !label){
        return;
    }
    lastActiveLabelName = labelName;

    if(label.childLabels.length == 0){
        label = label.parentLabel;
    }
    while(label){
        if(!label.isExpanded){
            changeExpand({target : label.domNode.previousSibling});
        }
        label = label.parentLabel;
    }
}

function updateUnreadCount(label)  {	
		for(var j = 0; j < label.childLabels.length; j++){
			label.unreadCount += updateUnreadCount(label.childLabels[j]);
		}
	
		var textNode       = uiHandler.getTextNode(label.domNode);
		var unreadCount    = (label.unreadCount > 0) ? " ("+label.unreadCount +")" : "";
		textNode.innerHTML = label.labelName + unreadCount;
		textNode.title     = label.labelName + unreadCount;
		
		return label.unreadCount;
}




//refreshes the label count in brackets for all labels
function refreshUnreadCounts() {
			for (var i = labelNameList.length-1; i >= 0; i--){
				for(index in labelArr) {
					var label = labelArr[index];
					
					if(label.labelName == labelNameList[i]) {
						var labelNode = oldLabelMap[labelNameList[i]];
						labelNode.className +=     " f4g_modified";
						var unreadCount = 0;
						
						if(uiHandler.hasUnreadMessages(labelNode)){
							var text = uiHandler.getTitleNode(labelNode).title;
							var regexResult = text.match(/\((\d+)\)$/);
							unreadCount = parseInt(regexResult[1]);
						}
						
						label.unreadCount = unreadCount;
					}
				}
			}
			
			for(index in labelArr) {
				var label = labelArr[index];
				
				if(label.parentLabel == null)
					updateUnreadCount(label);
			}
}


//label object
function Label(id){
    this.isExpanded = false;
	this.id = id;
	
    //set shortName
	this.fullLabelName = null;
	var labelNameArr = id.split("~");
    this.indentionLevel = 0;
	this.domNode = null;
	var rowNode = null;
	this.parentLabel = null;
	this.childLabels = new Array();
	
	this.unreadCount = 0;
	
	this.labelEditBox = null;
	
	var labelName = labelNameArr[0];
	this.labelName = labelName;
	
	if(labelNameArr.length > 0)
		this.parentLabel = labelNameArr[1];
	
	this.addChild = function(label) {
		this.childLabels.push(label);
	}
	
	this.setRowNode = function(node) {
		rowNode = node;
		
		rowNode.style.display = "";
	}
	
	this.getHREF = function()	{
		return searchURL + getQueryLabel(this) + AppendChildLabelClauses(this);
	}

	this.getRowNode = function() 	{
		var node = rowNode.firstChild.firstChild.firstChild;
		
		node.removeChild(node.firstChild);
		
		node.innerHTML = '<a href="' + this.getHREF()  + '" target="_top" style="color:#063">' + this.labelName + '</a>';
		
		this.domNode = node.firstChild;
		return rowNode;
	}
	
	this.displayEditBox = function() 	{
		if(this.labelEditBox.parentNode)
			this.labelEditBox.parentNode.removeChild(this.labelEditBox);
			
		rowNode.appendChild(this.labelEditBox);
	}
	
	/*
    //set htmlName, fixes Gmail Macros
    var nameStarts = fullLabelName.indexOf(labelName);
	
    //empty shortName
    if(labelName == ""){
        this.htmlName = "<span style=\"display:none\">" + fullLabelName + "</span>"
                      + "\u00A0";
    }else{
        this.htmlName = "";
        if(nameStarts > 0){
            this.htmlName += "<span style=\"display:none\">" + fullLabelName.substring(0, nameStarts) + "</span>"
        }

        this.htmlName += labelName;
        var postIndex = nameStarts + labelName.length < fullLabelName.length;
        if(postIndex){
            this.htmlName + "<span style=\"display:none\">" + fullLabelName.substring(postIndex) + "</span>";
        }
    }
	*/
}
 
 //check for parent label
function isParentLabelOf(parentLabelName, labelName){
    parentLabelName = standardSeparator(parentLabelName).toLowerCase() + "/";
    labelName       = standardSeparator(labelName).toLowerCase();
    return (labelName.indexOf(parentLabelName) == 0);
}


//if the parent label is not the direct parent, create the next missing parent in the document
//for example ("a", a/b/c/d") -> create "a/b"
//the input must be a real parent label
function addMissingParent(parentLabelName, labelName, labelNode){
    labelNameEscaped       = standardSeparator(labelName);
    var parentNameLenth    = (parentLabelName) ? parentLabelName.length+1 : 0;
    var missingParentLimit = labelNameEscaped.indexOf("/", parentNameLenth);
    var missingParentName  = (missingParentLimit > 0) ? labelName.substring(0, missingParentLimit) : null;

    if(missingParentName){
        uiHandler.addMissingParentNode(missingParentName, labelNode);
    }

    return missingParentName;
}


//create a new expand sign
function createExpandSign(doc, labelName){
    var expNode = doc.createElement("img");
        expNode.style.cssFloat    = "left";
        expNode.style.styleFloat  = "left"; //float for Internet Explorer
        expNode.style.marginTop   = "2px";
        expNode.style.marginRight = "2px";
        expNode.style.cursor      = "pointer";

        //fix Gmail Super Clean skin
        expNode.style.display     = "block";

    //set events

    if(expNode.addEventListener){
        expNode.addEventListener("click",     changeExpand,    false);
        expNode.addEventListener("mouseover", highlightAction, false);
        expNode.addEventListener("mouseout",  highlightAction, false);
    }
    //for Internet Explorer
    else if(expNode.attachEvent){
        expNode.attachEvent("onclick",     changeExpand);
        expNode.attachEvent("onmouseover", highlightAction);
        expNode.attachEvent("onmouseout",  highlightAction);
    }

    expNode.setAttribute("labelName", labelName);

    return expNode;
}


//event for a click on an expander
function changeExpand(evt){
    //srcElement for Internet Explorer
    var expanderNode  = (evt.target) ? evt.target : evt.srcElement;
    var labelName     = expanderNode.getAttribute("labelName");
    var label         = labelMap[labelName];
    var isHighlighted = (labelName == highlightedLabelName);
    label.isExpanded = !label.isExpanded;
    expanderNode.src = dataURIs[label.isExpanded][isHighlighted];
    var displayString = (label.isExpanded) ? "" : "none";
	//alert(labelName);
    //change display of child labels
    var changeDisplayed = new Array(label);
    while(changeDisplayed.length > 0){
        var changedLabel = changeDisplayed.pop();
        for(var i = 0; i < changedLabel.childLabels.length; i++){
            var childLabel = changedLabel.childLabels[i];
            if(childLabel.isExpanded)
                changeDisplayed.push(childLabel);
			else
				childLabel.displayEditBox();
				
            uiHandler.setDisplay(childLabel, displayString);
        }
    }
}


//convert separators that don't make sense to spaces
function standardSeparator(labelName){
    //converts the legacy separator "\" to "/"
    labelName = labelName.replace(/\\/g, "/");

    //convert "//" to "/ "
    var regexp = new RegExp("(/+)/");
    while(regexp.test(labelName)){
        labelName = labelName.replace(regexp, "$1 ");
    }

    //convert leading and trailing "/" to " "
    labelName = labelName.replace(new RegExp("^/"), " ");
    labelName = labelName.replace(new RegExp("/$"), " ");

    return labelName;
}


//mouse hover event
function highlightAction(evt){
    //srcElement for Internet Explorer
    var expanderNode  = (evt.target) ? evt.target : evt.srcElement;
    var labelName     = expanderNode.getAttribute("labelName");
    var isExpanded    = labelMap[labelName].isExpanded;
    var isHighlighted = (highlightedLabelName == labelName);

    highlightedLabelName = (isHighlighted) ? "" : labelName;
    expanderNode.src   = dataURIs[isExpanded][!isHighlighted];
}

